# Summary

- [Basics](./00_basic.md)
- [Literal](./01_literal.md)
- [Name](02_name.md)
- [Declaration](./03_declaration.md)
- [Function](./04_function.md)
- [Builtin Functions](./05_builtin_funcs.md)
- [Operator](./06_operator.md)
- [Side Effect](./07_side_effect.md)
- [Procedure](./08_procedure.md)
- [Builtin Procedures](./09_builtin_procs.md)
- [Array](./10_array.md)
- [Tuple](./11_tuple.md)
- [Dict](./12_dict.md)
- [Record](./13_record.md)
- [Set](./14_set.md)
- [Type](./15_type.md)
  - [Type System](./type/01_type_system.md)
  - [Basics](./type/02_basic.md)
  - [Trait](./type/03_trait.md)
  - [Class](./type/04_class.md)
  - [Inheritance](./type/05_inheritance.md)
  - [NST vs SST](./type/06_nst_vs_sst.md)
  - [Patch](./type/07_patch.md)
  - [Value Type](./type/08_value.md)
  - [Attributive Type](./type/09_attributive.md)
  - [Interval Type](./type/10_interval.md)
  - [Enum Type](./type/11_enum.md)
  - [Refinement Type](./type/12_refinement.md)
  - [Algebraic Type](./type/13_algebraic.md)
  - [Dependent Type](./type/14_dependent.md)
  - [Quantified Type](./type/15_quantified.md)
  - [Subtyping](./type/16_subtyping.md)
  - [Type Casting](./type/17_type_casting.md)
  - [Mutable Type](./type/18_mut.md)
  - [Advanced](./type/advanced.md)
    - [Default Parameter](./type/advanced/default_param.md)
    - [Type Erasure](./type/advanced/erasure.md)
    - [Existential](./type/advanced/existential.md)
    - [GADTs](./type/advanced/GADTs.md)
    - [Keyword Parameters](./type/advanced/keyword_param.md)
    - [Kind](./type/advanced/kind.md)
    - [Marker Trait](./type/advanced/marker_trait.md)
    - [Mutable Struct](./type/advanced/mut_struct.md)
    - [Phantom Type](./type/advanced/phantom.md)
    - [Projection Type](./type/advanced/projection.md)
    - [Quantified Dependent Type](./type/advanced/quantified_dependent.md)
    - [Shared](./type/advanced/shared.md)
- [Iterator](./16_iterator.md)
- [Mutability](./17_mutability.md)
- [Ownership](./18_ownership.md)
- [Visibility](./19_visibility.md)
- [Naming Rule](20_naming_rule.md)
- [Lambda](./21_lambda.md)
- [Subroutine](./22_subroutine.md)
- [Closure](./23_closure.md)
- [Module](./24_module.md)
- [Object System](./25_object_system.md)
- [Pattern Matching](./26_pattern_matching.md)
- [Comprehension](./27_comprehension.md)
- [Spread Syntax](./28_spread_syntax.md)
- [Decorator](./29_decorator.md)
- [Error Handling](./30_error_handling.md)
- [Pipeline](./31_pipeline.md)
- [Integration With Python](./32_integration_with_Python.md)
- [Package System](./33_package_system.md)
- [Generator](./34_generator.md)
- [Quick Tour](./quick_tour.md)
- [Index](./indexes.md)
